Subject: Re: [bitcoin-dev] Drivechain RfD -- Follow Up

From: Paul Sztorc <[email-masked]>
Date: Tue, 20 Jun 2017 07:54:52 -0400

Hi Erik,

As you know:

1. If a sidechain is merged mined it basically grows out of the existing
Bitcoin mining network. If it has a different PoW algorithm it is a new
mining network.
2. The security (ie, hashrate) of any mining network would be determined
by the total economic value of the block. In Bitcoin this is
(subsidy+tx_fees)*price, but since a sidechain cannot issue new tokens
it would only be (tx_fees)*price.

Unfortunately the two have a nasty correlation which can lead to a
disastrous self-fulfilling prophecy: users will avoid a network that is
too insecure; and if users avoid using a network, they will stop paying
txn fees and so the quantity (tx_fees)*price falls toward zero, erasing
the network's security. So it is quite problematic and I recommend just
biting the bullet and going with merged mining instead.

And, the point may be moot. Bitcoin miners may decide that, given their
expertise in seeking out cheap sources of power/cooling, they might as
well mine both/all chains. So your suggestion may not achieve your
desired result (and would, meanwhile, consume more of the economy's
resources -- some of these would not contribute even to a higher hashrate).

Paul

On 6/19/2017 1:11 PM, Erik Aronesty wrote:
> It would be nice to be able to enforce that a drivechain *not* have
> the same POW as bitcoin.
>
> I suspect this is the only way to be sure that a drivechain doesn't
> destabilize the main chain and push more power to miners that already
> have too much power.
>
>
> On Mon, Jun 19, 2017 at 12:04 PM, Paul Sztorc via bitcoin-dev
> <[email-masked]
> <mailto:[email-masked]>> wrote:
>
>     Hi Greg,
>
>     Responses below:
>
>     On 6/18/2017 5:30 PM, Tao Effect wrote:
>     > In Drivechain, 51% of miners have total control and ownership
>     over all
>     > of the sidechain coins.
>
>     It would not be accurate to say that miners have "total" control.
>     Miners
>     do control the destination of withdrawals, but they do not control the
>     withdrawal-duration nor the withdrawal-frequency.
>
>     So, if miners wish to 'steal' from a sidechain, they _can_ initiate a
>     theft, but they can not change the fact that their malfeasance will be
>     [a] obvious, and [b] on display for a long period of time.
>
>     We might draw a comparison between:
>
>     1. Classic Theft   -- A majority hashrate reorganizes the main Bitcoin
>     chain to double-spend funds (or coordinate with someone who is
>     double-spending). This is prevented/discouraged by waiting for many
>     confirmations.
>     2. Channel Theft -- A majority hashrate assists a Lightning-Network
>     thief, by censoring the punitive audit txn (possibly by exploiting
>     some
>     excuse regarding fullness of blocks, or possibly induced to do so
>     by the
>     thief provably splitting the proceeds with miners). This is
>     prevented/discouraged by using lengthy custodial periods, paying high
>     fees with your attacker's money, and using
>     fungibility/non-communication
>     to interact with miners as little as possible (so as to frame LN-theft
>     as undermining the entire LN system, and not merely a single tragedy).
>     3. Drivechain Theft -- A majority hashrate initiates an
>     unrepresentative
>     withdrawal from some sidechain. This is prevented/discouraged by only
>     using 'popular' sidechains (those that [a] increase the usefulness
>     ("market price") of bitcoin, and [b] generate tx fees for miners).
>     It is
>     also discouraged by the fact that egregious theft would probably
>     end the
>     sidechain experiment, meaning that all present and future sidechains
>     would be forever unavailable (and unable to buoy the price or the tx
>     revenues).
>
>     I do not think that any of the three stands out as being categorically
>     worse than the others, especially when we consider the
>     heterogeneity of
>     use-cases and preferences. As Luke-Jr has been pointing out on social
>     media recently, the very group which is more associated with
>     miners (and
>     explicitly more willing to trust them, ie Bitcoin Unlimited et al),
>     happens to be the same group that would be expected to make use of a
>     LargeBlock drivechain. Some can argue that one type of security is
>     more
>     "cryptographic" than others, but I think this is misguided (how many
>     'bits' of security does each have?) -- imho, all three security models
>     are 'game theoretic' (neither computer scientific, nor cryptographic).
>
>     More importantly, before a miner has any "control" over the sidechain
>     coins, users must voluntarily agree to subject themselves to these new
>     rules. This is similar to how an arbitrary piece of (open source)
>     software can have "total" control over your computer...if you
>     choose to
>     install it.
>
>     > Thus the effect of Drivechain appears to be the creation of a
>     new kind
>     > of digital border imposed onto the network ...
>
>     I'm not sure it would "create a border", given that sidechains are
>     currently not accessible at all. If anything drivechain cuts a
>     door into
>     an existing impassible border.
>
>     >  ... where everyone hands over ownership of their Bitcoins to a
>     > /single/ mining cartel when they wish to interact with /any/ sidechain.
>
>     The qualifier "/any/ sidechain" would seem to imply that there is
>     a way
>     to do sidechains that does not involve handing over some control
>     to 51%
>     hashrate...I think this is false (even in the fabled case of
>     ZK-SNARKS).
>     The first thing I do in the drivechain spec (
>     truthcoin.info/blog/drivechain
>     <http://truthcoin.info/blog/drivechain> ) is explain why.
>
>     > Drivechain would be a reasonable idea if that weren't the case, but
>     > since it is, Drivechain now introduces a very real possible future
>     > where Bitcoins can be confiscated by the Chinese government in
>     exactly
>     > the same manner that the Chinese government today confiscates
>     > financial assets in other financial networks within China.
>
>     Yes, but money could also be confiscated from _any_ Bitcoin users
>     (Chinese or otherwise) using any of the three methods I mentioned
>     above.
>     And confiscation could strike Chinese Bitcoin users if they decided to
>     sell their Bitcoin for Chinese Yuan, which they then deposited in a
>     Chinese bank. Or if they sold their Bitcoin for an Altcoin
>     controlled by
>     the Chinese govt in some other way.
>
>     It is not up to the members of this list to decide, USSR style, what
>     other people are allowed to do with their own money.
>
>     The exceptions to this rule would be (ie, "bitcoin-dev should care
>     about
>     what users are doing when..."):
>
>     1. [Unreasonable use of Reviewer Time]  The user's use-case is either
>     nonexistent (ie "no one wants that"), or totally unachievable ("we
>     can't
>     do that") thus rendering the conversation a complete waste of time /
>     reviewer attention.
>     2. [Harmful Interference] The user's use-case would impose harm on
>     some
>     existing use-case(s).
>
>     No reasonable person will claim the first, given today's scaling
>     debate
>     (not to mention today's 'bitcoin dominance index'). Therefore, critics
>     must claim the second (as, for example, Peter Todd has been doing on
>     this list).
>
>     Which is why I narrowly focus on inter-chain harms [1], leading
>     ultimately to a focus on the mining ecosystem [2,3] and the
>     development
>     of Blind Merged Mining [4].
>
>     [1]
>     https://www.youtube.com/watch?v=0goYH2sDw0w&list=PLw8-6ARlyVciNjgS_NFhAu-qt7HPf_dtg&index=1
>     <https://www.youtube.com/watch?v=0goYH2sDw0w&list=PLw8-6ARlyVciNjgS_NFhAu-qt7HPf_dtg&index=1>
>     [2] http://www.truthcoin.info/blog/mirage-miner-centralization/
>     <http://www.truthcoin.info/blog/mirage-miner-centralization/>
>     [3] http://www.truthcoin.info/blog/mining-threat-equilibrium/
>     <http://www.truthcoin.info/blog/mining-threat-equilibrium/>
>     [4] http://www.truthcoin.info/blog/blind-merged-mining/
>     <http://www.truthcoin.info/blog/blind-merged-mining/>
>     [5] http://www.truthcoin.info/blog/measuring-decentralization/
>     <http://www.truthcoin.info/blog/measuring-decentralization/>
>
>     > 1. The Bitcoin network centralizes more, because more power (both
>     > financial power and power in terms of capability/control) is granted
>     > to miners.
>
>     I think that one has some duty to very clearly define something (like
>     "mining centralization" [2] or "centralization" [5]) before
>     complaining
>     about it. I feel that people will occasionally use selfless complaints
>     to accomplish a selfish goal...especially when the artificial selfless
>     part is hard to discuss by virtue of its being poorly defined
>     (especially vague or abstract items like "the company", "our country",
>     etc). For example, those who take it upon themselves to "defend" "the
>     Bitcoin community" may have exactly that in mind as their primary
>     goal...but they may also end up with more visibility (and with it:
>     more
>     influence, more job offers, more conference invites, more friends,
>     etc)
>     and they may also end up with a megaphone for which to broadcast their
>     other views, or just a defend-able excuse for bragging loudly
>     about how
>     great cypherpunks are and/or how devoted they-in-particular are to the
>     cypherpunk tribe, et cetera. To avoid this problem in my own technical
>     discourse, I try to avoid abstractions like "centralization" until I
>     have defined them [2,5].
>
>     You have defined centralization above, but the definition is itself
>     vague to the point where I do not think even you actually endorse it.
>     For example, you would need to say that Bitcoin centralizes
>     whenever the
>     exchange rate increases (as this grants additional financial power to
>     miners) or when any new user joins Bitcoin, or when tx fee revenues
>     increase for any reason. You might also be forced to say that LN
>     centralizes Bitcoin (as LN grants new capability/control to
>     miners), and
>     probably even that Bitcoin becomes more centralized when developers
>     release new software (as this grants new capability to miners,
>     specifically the ability to deny upgrades). This probably isn't
>     what you
>     meant, but since you did not clearly explain what you meant we have no
>     way of knowing for sure.
>
>     It seems to me that you reject the premise that BMM [4] addresses
>     these
>     issues. This is probably because BMM only addresses miner's
>     interactions
>     with each other, and it does not address miner abilities as a group in
>     relation to other groups (for example, vs. users, developers,
>     investors). But, as I consistently emphasize, these groups of
>     people are
>     free to ignore any sidechains that they do not like. In law there is a
>     saying 'volenti non fit injuria' which I would translate as "he who
>     volunteers cannot claim later to have been injured". This is a legal
>     theory, because otherwise everyone would be arbitrarily liable for
>     choices beyond their control (ie, responsible for decisions of other
>     unrelated people), which would be nonsense.
>
>     > 3. Drivechain limits user's existing choice when it comes to who is
>     > acting as custodian of their Bitcoins, from any trustworthy
>     exchange,
>     > down to a single mining cartel under the control of a single set
>     of laws.
>
>     Currently no (P2P) sidechains exist, and therefore the set of choices
>     today would seem to be more "limited" than in a post-sidechain future.
>     (The set of options may decrease later, for ecological reasons, if and
>     only if 'exchanges' are a strictly inferior option to 'sidechains' for
>     some reason...I don't see why this would be the case. I also don't
>     understand the emphasis on "exchanges" [SCs are much more like
>     Altcoins,
>     than exchanges] in the first place, nor the dubious qualifier
>     "trustworthy".)
>
>     --Paul
>
>     _______________________________________________
>     bitcoin-dev mailing list
>     [email-masked]
>     <mailto:[email-masked]>
>     https://lists.linuxfoundation.org/mailman/listinfo/bitcoin-dev
>     <https://lists.linuxfoundation.org/mailman/listinfo/bitcoin-dev>
>
>